#@+leo-ver=4
#@+node:@file C:/Projects/PyMotion/varticker.py
#@@language python
#@<< varticker declarations >>
#@+node:<< varticker declarations >>
#!/usr/bin/env python

import math

#@-node:<< varticker declarations >>
#@nl
#@+others
#@+node:class VariableTicker
class VariableTicker:
    """A ticker class where ticks proceed at varying speeds, based on
       a specified series of linear accelerations."""
    #@	<< class VariableTicker declarations >>
    #@+node:<< class VariableTicker declarations >>
    speed_table = [[0, 0, 0]]
        # The table to lookup tick speeds. It is in the form:
        #     [[end_tick, start_vel, accel], [end_tick, start_vel, accel], ...]
    
    curr_tick = 0
    #@nonl
    #@-node:<< class VariableTicker declarations >>
    #@nl
    #@	@+others
    #@+node:__init__
    def __init__ (self, segments):
        
        if len(segments) % 3 != 0:
            print "Segments is in the wrong format."
            return
    
        self.speed_table = [[0, 0, 0]]
        seg_start = 0
        print "num segments ", len(segments)/3
        
        for i in range(len(segments)/3):
            seg_end = seg_start + segments[3*i + 2]
            seg_start_val = segments[3*i]
            seg_slope = float(segments[3*i + 1] - seg_start_val) / segments[3*i + 2]
    
            self.speed_table.append([seg_end, seg_start_val, seg_slope])
    
            seg_start = seg_end
        
    #@nonl
    #@-node:__init__
    #@+node:tick
    def tick(self):
        "Moves ticker to the next tick"
    
        for i in range(1, len(self.speed_table)):
            if (self.speed_table[i][1] == 0) and (self.speed_table[i][2] == 0):
                print "I'm zero, yay!"
            if self.curr_tick < self.speed_table[i][0]:
                ticks_in_seg = self.curr_tick - self.speed_table[i-1][0]
                tick_diff = self.speed_table[i][1]
                tick_diff += self.speed_table[i][2] * ticks_in_seg
    
                self.curr_tick += tick_diff
                break
    #@nonl
    #@-node:tick
    #@-others
#@-node:class VariableTicker
#@-others
#@-node:@file C:/Projects/PyMotion/varticker.py
#@-leo
